'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _virtex = require('virtex');

var _forEach = require('./forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _svg = require('./svg');

var _svg2 = _interopRequireDefault(_svg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Constants
 */

var setAttribute = _virtex.actions.setAttribute; /**
                                                  * Imports
                                                  */

var cache = {};

/**
 * Create a DOM element
 */

function createElement(doc, dispatch, _ref) {
  var tag = _ref.tag;
  var attrs = _ref.attrs;
  var children = _ref.children;

  if (typeof cache[tag] === 'undefined') {
    cache[tag] = _svg2.default.isElement(tag) ? doc.createElementNS(_svg2.default.namespace, tag) : doc.createElement(tag);
  }

  var node = cache[tag].cloneNode(false);

  if (attrs !== null) {
    for (var key in attrs) {
      var val = attrs[key];
      if (val !== null && val !== undefined) {
        dispatch(setAttribute(node, key, val));
      }
    }
  }

  for (var i = 0, len = children.length; i < len; ++i) {
    node.appendChild(children[i].el);
  }

  return node;
}

/**
 * Exports
 */

exports.default = createElement;